; 4spyxx by kero, v.2010-06-17.
; amplifier for Window Finder of Spy++.
; tested for Spy++ vv from 4.00.5277 to 10.0.30319.

.386
.model flat,stdcall
option casemap:none

inclib macro x
 include x.inc
 includelib x.lib
endm

include windows.inc
inclib  user32
inclib  kernel32
inclib  gdi32

.data
rgstr		db "amplifier for spy++ by kero",0
_child  db "SpyxxProcessPacket",0
_spy		db " Spy++  ?",0
_sel		db " Select",0
_prop		db " Properties",0
_mess		db " Messages",0
_aref		db " Auto  Refresh",0
_asel		db " Auto  Select",0
_zpnt		db " Z  Up/Down",0
ft			db "%8.8lX",0

.data?
hrgn		HRGN ?
hwspy   dd ?
hwfnd   dd ?
flag		dd ?
rcount	dd ?
zcount	dd ?
mcount	dd ?
num			dd ?
rgstrid	dd ?
hmenu		dd ?
menuid	dd ?
pnt			POINT <>
buf1		db 256 dup(?)

.code

LastPopup proc hWnd:HWND
@@: 	  
	invoke GetLastActivePopup,hWnd
	.if eax==hWnd
		invoke Sleep,20
		jmp @b
	.endif
	ret
LastPopup endp

RefreshSelect proc uses ebx hWnd:DWORD,lpbuf:DWORD
	invoke PostMessage,hWnd,WM_COMMAND,5008,0  ; "Refresh"
	invoke PostMessage,hWnd,WM_COMMAND,5024,0  ; "Find Object..." - Spyxx_v4/Spyxx_v6, "Find Message..." - Spyxx_v7
  invoke PostMessage,hWnd,WM_COMMAND,5043,0  ; "Find Message..." - Spyxx_v10
	invoke LastPopup,hWnd
	mov ebx,eax
	invoke GetDlgItem,ebx,1625
	mov ecx,eax
	invoke SendMessageTimeout,ecx,WM_SETTEXT,0,lpbuf,SMTO_ABORTIFHUNG OR SMTO_BLOCK,500,0
	invoke PostMessage,ebx,WM_COMMAND,1,0
@@:
	invoke IsWindow,ebx
	.if eax!=0
		invoke Sleep,20
		jmp @b
	.endif
	invoke PostMessage,hWnd,WM_COMMAND,5020,0 ; "Expand Branch"
	ret
RefreshSelect endp

ChildWindowUnderCursor proc uses ebx hWnd:HWND
	local pt:POINT
	mov ebx,hWnd
	invoke GetCursorPos,addr pt
	mov ecx,ebx
@@: 
	invoke MapWindowPoints,ecx,ebx,addr pt,1
;	invoke ChildWindowFromPointEx,ebx,pt.x,pt.y,CWP_SKIPINVISIBLE  ; CWP_ALL
	invoke RealChildWindowFromPoint,ebx,pt.x,pt.y
	.if eax!=0 && eax!=ebx
		mov ecx,ebx
		mov ebx,eax
		jmp @b
	.endif
	mov eax,ebx
	ret
ChildWindowUnderCursor endp

ZFromPoint proc uses ebx edi esi hWnd:DWORD,param:DWORD
	local rt:RECT
	invoke GetWindowRect,hWnd,addr rt
	invoke PtInRect,addr rt,pnt.x,pnt.y
	mov ebx,eax
	invoke GetWindowRgn,hWnd,hrgn
	mov edi,eax
	mov eax,pnt.x
	sub eax,rt.left
	mov ecx,pnt.y
	sub ecx,rt.top
	invoke PtInRegion,hrgn,eax,ecx
	mov esi,eax
	.if ebx!=0 && (edi==0 || (edi!=0 && esi!=0))
		mov eax,zcount
		.if eax==num
			mov eax,hWnd
			.if eax!=hwfnd
				mov hwfnd,eax
				invoke wsprintf,addr buf1,offset ft,eax
				invoke RefreshSelect,hwspy,addr buf1
			.endif
			xor eax,eax
			jmp @f
		.endif
		inc zcount
	.endif
	xor eax,eax
	inc eax
@@:
	ret
ZFromPoint endp

EnumCh proc hWnd:DWORD,param:DWORD
	local buf[256]:BYTE
	invoke GetClassName,hWnd,addr buf,255
	invoke lstrcmp,addr buf,addr _child
	.if eax==0
		invoke GetAncestor,hWnd,GA_ROOT
		mov hwspy,eax
		invoke GetWindowLong,hwspy,GWL_STYLE
		and eax,not WS_MINIMIZEBOX
		invoke SetWindowLong,hwspy,GWL_STYLE,eax
		invoke SetWindowPos,hwspy,HWND_TOPMOST,0,0,0,0,SWP_NOMOVE OR SWP_NOSIZE OR SWP_FRAMECHANGED
		xor eax,eax
	.endif
	ret
EnumCh endp


DlgProc proc uses ebx edi esi hWnd:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM
	local pt:POINT

	mov eax,uMsg
	mov ecx,lParam
	.if	eax==WM_CLOSE
		invoke KillTimer,hWnd,1
		invoke DeleteObject,hrgn
		invoke IsWindow,hwspy
		.if eax!=0
			invoke GetWindowLong,hwspy,GWL_STYLE
			or eax,WS_MINIMIZEBOX
			invoke SetWindowLong,hwspy,GWL_STYLE,eax
			invoke SetWindowPos,hwspy,HWND_NOTOPMOST,0,0,0,0,SWP_NOMOVE OR SWP_NOSIZE OR SWP_FRAMECHANGED
		.endif
		invoke EndDialog,hWnd,0

	.elseif	eax==rgstrid && ecx!=hWnd
		invoke PostMessage,ecx,WM_CLOSE,0,0

	.elseif eax==WM_INITDIALOG
		invoke GetMenu,hWnd
		mov hmenu,eax
;		invoke RegisterWindowMessage,offset rgstr
		.data?
		wc WNDCLASS <>
		.code
		mov wc.lpszClassName,offset rgstr
		invoke RegisterClass,offset wc
		and eax,0ffffh
		mov rgstrid,eax
		invoke PostMessage,HWND_BROADCAST,eax,0,hWnd
		invoke CreateRectRgn,0,0,0,0
		mov hrgn,eax
		invoke SetTimer,hWnd,1,40,0

	.elseif eax==WM_COMMAND && hwspy!=0
		mov eax,wParam
		.if eax>=500 && eax<=505
			mov flag,eax
			.if eax==500
@@@:
				mov eax,offset _sel
			.elseif eax==501
				mov eax,offset _asel
			.elseif eax==502
				mov eax,offset _zpnt
			.elseif eax==503
				mov eax,offset _prop
			.elseif eax==504
				mov eax,offset _mess
			.elseif eax==505
				mov eax,offset _aref
			.endif
			invoke SetWindowText,hWnd,eax
			invoke IsWindow,hwfnd
			.if eax!=0
				invoke RefreshSelect,hwspy,addr buf1
			.else
				mov hwfnd,eax
				mov byte ptr[buf1],al
				mov eax,5008 ; "Refresh"
				jmp @f
			.endif
		.else
@@:
			invoke PostMessage,hwspy,WM_COMMAND,eax,0
			.if wParam==5010 ; "Windows"
				invoke PostMessage,hwspy,WM_COMMAND,57652,0 ; "Tile Vertically"
			.endif
		.endif

	.elseif eax==WM_TIMER
		invoke GetKeyState,VK_SHIFT
		and eax,8000h
		mov edi,eax
		invoke GetDesktopWindow
		mov ebx,eax
		.if hwspy==0
			invoke EnumChildWindows,ebx,addr EnumCh,0
			.if hwspy!=0
				mov flag,500
				invoke SetWindowText,hWnd,offset _sel
				invoke PostMessage,hwspy,WM_COMMAND,5008,0  ; "Refresh"
			.endif
		.else
			invoke IsWindow,hwspy
			.if eax==0
				mov hwspy,eax
				mov hwfnd,eax
				mov byte ptr[buf1],al
				invoke SetWindowText,hWnd,offset _spy
			.else
				invoke ChildWindowUnderCursor,ebx
				mov esi,eax
				.if edi==0
					.if flag==501 && esi!=hwfnd
						mov hwfnd,esi
						invoke wsprintf,addr buf1,offset ft,esi
						invoke RefreshSelect,hwspy,addr buf1
					.elseif flag==505 && rcount>40
						mov rcount,0
						invoke RefreshSelect,hwspy,addr buf1
					.elseif flag==502
						invoke GetKeyState,VK_UP
						and eax,8000h
						push eax
						invoke GetKeyState,VK_DOWN 
						and eax,8000h
						pop ecx
						.if eax!=0 || ecx!=0
							.if ecx!=0 && num>0
								dec num
							.elseif eax!=0
								inc num
							.endif
@@:
							mov zcount,0
							invoke EnumChildWindows,ebx,addr ZFromPoint,0
							invoke Sleep,300
						.endif
					.endif
				.else
					.if flag==502
						invoke GetCursorPos,addr pnt
						mov num,0
						jmp @b
					.else
						.if esi!=hwfnd
							mov hwfnd,esi
							invoke wsprintf,addr buf1,offset ft,esi
	    			.endif
						invoke RefreshSelect,hwspy,addr buf1
						.if flag==501
							mov flag,500
							jmp @@@
						.elseif flag==503
							invoke PostMessage,hwspy,WM_COMMAND,5003,0 ; "Properties..."
						.elseif flag==504
							invoke PostMessage,hwspy,WM_COMMAND,5023,0  ; "Find Window..."
							invoke LastPopup,hwspy
							mov ebx,eax
							invoke GetDlgItem,ebx,1616
							invoke PostMessage,eax,BM_CLICK,0,0
@@:   		
							invoke IsDlgButtonChecked,ebx,1616
							.if eax==0
								invoke Sleep,20
								jmp @b
							.endif
							invoke GetDlgItem,ebx,1617
							mov ecx,eax
							invoke SendMessageTimeout,ecx,WM_SETTEXT,0,addr buf1,SMTO_ABORTIFHUNG OR SMTO_BLOCK,500,0
							invoke PostMessage,ebx,WM_COMMAND,1,0
@@:     	
							invoke IsWindow,ebx
							.if eax!=0
								invoke Sleep,20
								jmp @b
							.endif
							invoke PostMessage,hwspy,WM_COMMAND,57651,0  ; "Tile Horizontally"
						.endif
						invoke Sleep,300
					.endif
				.endif
			.endif
		.endif
		inc rcount
		inc mcount
		invoke GetCursorPos,addr pt
		invoke MenuItemFromPoint,hWnd,hmenu,pt.x,pt.y
		.if eax==-1 || eax!=menuid
			mov menuid,eax
			xor eax,eax
			mov mcount,eax
		.else
			.if mcount==50
				.if eax>=0 && eax<=5
					add eax,500
				.elseif eax==6
					mov eax,5008
				.elseif eax==7
					mov eax,5010
				.else
					mov eax,555
				.endif
				invoke PostMessage,hWnd,WM_COMMAND,eax,0
			.endif
		.endif

	.else
		xor eax,eax
		jmp @f
	.endif
	xor eax,eax
	inc eax
@@:
	ret
DlgProc endp

start:
	invoke GetModuleHandle,0
	invoke DialogBoxParam,eax,1,0,offset DlgProc,0
;	ret
	invoke ExitProcess,eax
end start
